Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  laz.VirtualTrees;

Type

  TNodeData = Record
    TaskPrimKey: String;
    Columns: Array Of String;
  End;

  PNodeData = ^TNodeData;

  { TForm1 }

  TForm1 = Class(TForm)
    LazVirtualStringTree1: TLazVirtualStringTree;
    Memo1: TMemo;
    Procedure FormCreate(Sender: TObject);
    Procedure LazVirtualStringTree1Click(Sender: TObject);
    Procedure LazVirtualStringTree1FreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    Procedure LazVirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree;
      Var NodeDataSize: Integer);
    Procedure LazVirtualStringTree1GetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      Var CellText: String);
  private

  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

Uses math;

{ TForm1 }

Procedure TForm1.LazVirtualStringTree1Click(Sender: TObject);
Var
  Data: PNodeData;
Begin
  If Not Assigned(LazVirtualStringTree1.FocusedNode) Then Exit;
  Data := LazVirtualStringTree1.GetNodeData(LazVirtualStringTree1.FocusedNode);
  If Not Assigned(Data) Then exit;
  memo1.lines.add('Click' + data^.TaskPrimKey);
End;

Procedure TForm1.FormCreate(Sender: TObject);
Var
  vth: TVirtualTreeColumn;
  aRoot, ANode: PVirtualNode;
  Data: PNodeData;
  i: Integer;
Begin
  // ReInit Treeview
  LazVirtualStringTree1.Clear;
  LazVirtualStringTree1.Header.Columns.Clear;


  vth := LazVirtualStringTree1.Header.Columns.Add;
  vth.Text := 'Category';
  vth.Width := 300;
  vth := LazVirtualStringTree1.Header.Columns.Add;
  vth.Text := 'State';
  vth.Width := 70;
  vth := LazVirtualStringTree1.Header.Columns.Add;
  vth.Text := 'Priority';
  vth.Width := 70;
  vth := LazVirtualStringTree1.Header.Columns.Add;
  vth.Text := 'Deadline';
  vth.Width := 70;
  vth := LazVirtualStringTree1.Header.Columns.Add;
  vth.Text := 'Duration';
  vth.Width := LazVirtualStringTree1.Width - 300 - 70 - 70 - 70 - 20;

  aRoot := LazVirtualStringTree1.AddChild(Nil);
  data := LazVirtualStringTree1.GetNodeData(aRoot);
  data^.TaskPrimKey := 'root';
  setlength(data^.Columns, 1);
  data^.Columns[0] := 'root';
  For i := 0 To 4 Do Begin
    ANode := LazVirtualStringTree1.AddChild(aRoot);
    data := LazVirtualStringTree1.GetNodeData(ANode);
    setlength(data^.Columns, 5);
    data^.TaskPrimKey := inttostr(i);
    data^.Columns[0] := data^.TaskPrimKey;
    data^.Columns[1] := inttostr(Random(100));
    data^.Columns[2] := inttostr(Random(100));
    data^.Columns[3] := inttostr(Random(100));
    data^.Columns[4] := inttostr(Random(100));

  End;

  LazVirtualStringTree1.FullExpand();
End;

Procedure TForm1.LazVirtualStringTree1FreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
Var
  Data: PNodeData;
Begin
  Data := LazVirtualStringTree1.GetNodeData(Node);
  If Assigned(Data) Then Begin
    setlength(data^.Columns, 0);
    data^.TaskPrimKey := '';
  End;
End;

Procedure TForm1.LazVirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree;
  Var NodeDataSize: Integer);
Begin
  NodeDataSize := SizeOf(TNodeData);
End;

Procedure TForm1.LazVirtualStringTree1GetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  Var CellText: String);
Var
  Data: PNodeData;
Begin
  CellText := '';
  Data := LazVirtualStringTree1.GetNodeData(Node);
  Column := max(Column, 0);
  If high(data^.Columns) >= Column Then Begin
    CellText := Data^.Columns[Column];
  End;
End;

End.

